#!/usr/bin/env python
import crypt
import ldap
import string
import re
import sys
from datetime import date

def parse_date(date):
	list = string.split(date, "/")
	list.reverse()
	return int(string.join(list, ""))

last_date = 0

# Get 'localidad' and 'provincia' from config file
def read_conf(file):
	f = open(file, "r")
	f_content = f.read()
# Cambiado para que funcione con ids no numricas
#	result = re.findall('ID_LOCALIDAD="(\d+)"', f_content)
	result = re.findall('ID_LOCALIDAD="(\S+)"', f_content)
	localidad = result[0]
#	result = re.findall('ID_PROVINCIA="(\d+)"', f_content)
	result = re.findall('ID_PROVINCIA="(\S+)"', f_content)
	provincia = result[0]
	return (localidad, provincia)

now = date.today()

(localidad, provincia) = read_conf("/etc/guadalinfo_id.conf")

conn = ldap.initialize("ldap://localhost")

attr_list = ['uid', 'sex', 'education', 'birthDate', 'workActivity', 'income', 'startDate']
conn.simple_bind('cn=admin, o=guadalinex, c=es', 'wadA15')
query_result = conn.search('o=guadalinex,c=es', ldap.SCOPE_SUBTREE, '(uid=*)', attr_list)

content = ""

while 1:
	result_type, result_data = conn.result(query_result, 0)
	if (result_data == []):
		break
	else:
		if result_type == ldap.RES_SEARCH_ENTRY:
			(dn, attrs) = result_data[0]
			try:
				user = crypt.crypt(attrs['uid'][0], "dc")
				for i in attr_list:
					if not attrs.has_key(i):
						attrs[i] = ['']
				item = user + ";" + attrs['sex'][0] + ";" + attrs['education'][0] + ";" + attrs['birthDate'][0] + ";" + attrs['workActivity'][0] + ";" + attrs['income'][0] + ";" + attrs['startDate'][0] + ";" + now.strftime("%m")
				content = content + item + "\n"
				if attrs['startDate'][0] != '':
					date = parse_date(attrs['startDate'][0])
					if date > last_date:
						last_date = date
			except TypeError, msg:
				print msg
				raise
			except:
				print ("Error: %s" % sys.exc_info()[0])

try:
	f_dest = open("/tmp/" + provincia + "_" + localidad + "_" + str(last_date) + "_usuarios", "w")
except:
	f_dest = open("/tmp/" + provincia + "_" + localidad + "_" + "0" + "_usuarios", "w")
f_dest.write(content)
f_dest.close()

conn.unbind()

